diff --git a/game/client/src/main/java/net/betterthanadventure/utils/DataDumper.java b/game/client/src/main/java/net/betterthanadventure/utils/DataDumper.java
index da9d8804a..e989e6a4a 100644
--- a/game/client/src/main/java/net/betterthanadventure/utils/DataDumper.java
+++ b/game/client/src/main/java/net/betterthanadventure/utils/DataDumper.java
@@ -21,6 +21,7 @@ import net.minecraft.core.item.tool.ItemToolPickaxe;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.biome.Biome;
+import net.minecraft.core.world.biome.BiomeTags;
 import net.minecraft.core.world.chunk.ChunkLoader;
 import net.minecraft.core.world.chunk.provider.ChunkProvider;
 import net.minecraft.core.world.weather.Weather;
@@ -147,10 +148,10 @@ public class DataDumper implements MinecraftAccessor {
                 .append(Registries.BIOMES.getNumericIdOfItem(biome)).append(",")
                 .append(biome.translationKey).append(",")
                 .append(String.format("0x%06X", biome.color)).append(",")
-                .append(Blocks.blocksList[biome.topBlock].getKey()).append(",")
-                .append(Blocks.blocksList[biome.fillerBlock].getKey()).append(",")
-                .append(biome.hasSurfaceSnow()).append(",")
-                .append(biome.hasSurfaceIce()).append(",");
+                .append(biome.getSurfaceProperties().getTopBlock().getKey()).append(",")
+                .append(biome.getSurfaceProperties().getFillerBlock().getKey()).append(",")
+                .append(biome.hasTag(BiomeTags.HAS_SURFACE_SNOW)).append(",")
+                .append(biome.hasTag(BiomeTags.HAS_SURFACE_ICE)).append(",");
 
         builder.append("\"");
 
diff --git a/game/client/src/main/java/net/minecraft/client/discord/RichPresenceHandlerThread.java b/game/client/src/main/java/net/minecraft/client/discord/RichPresenceHandlerThread.java
index 744f0ece3..a1643471c 100644
--- a/game/client/src/main/java/net/minecraft/client/discord/RichPresenceHandlerThread.java
+++ b/game/client/src/main/java/net/minecraft/client/discord/RichPresenceHandlerThread.java
@@ -56,7 +56,7 @@ public class RichPresenceHandlerThread extends Thread {
         biomeNamesMap.put(Biomes.OVERWORLD_MEADOW, "a meadow");
         biomeNamesMap.put(Biomes.NETHER_CRAG, "the crag");
         biomeNamesMap.put(Biomes.NETHER_CRYSTAL_FOREST, "a crystal forest");
-        biomeNamesMap.put(Biomes.NETHER_CRYSTAL_FIELD, "a crystal field");
+        biomeNamesMap.put(Biomes.NETHER_CRYSTAL_PLAINS, "a crystal field");
         biomeNamesMap.put(Biomes.NETHER_SULFUR_POOLS, "the sulfur pools");
         biomeNamesMap.put(Biomes.NETHER_VOLCANIC_ISLANDS, "a volcanic island");
         biomeNamesMap.put(Biomes.NETHER_OLD_WORLD, "the crag (cold)");
diff --git a/game/client/src/main/java/net/minecraft/client/render/FogManager.java b/game/client/src/main/java/net/minecraft/client/render/FogManager.java
index 8940c6dfa..f179204db 100644
--- a/game/client/src/main/java/net/minecraft/client/render/FogManager.java
+++ b/game/client/src/main/java/net/minecraft/client/render/FogManager.java
@@ -6,6 +6,7 @@ import net.minecraft.client.option.GameSettings;
 import net.minecraft.client.world.WorldClient;
 import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.type.tag.WorldTypeTags;
 import org.jetbrains.annotations.NotNull;
 import org.joml.Vector3fc;
 import org.joml.Vector4f;
@@ -99,7 +100,7 @@ public class FogManager {
                     dest.fogStart = 0.0F;
                     dest.fogEnd = fogDistance * 0.8F;
                 }
-                if (this.mc.currentWorld.dimension == Dimension.NETHER) {
+                if (this.mc.currentWorld.getWorldType().hasTag(WorldTypeTags.NETHER)) {
                     dest.fogStart = 0.0F;
                 }
             }
@@ -134,7 +135,7 @@ public class FogManager {
             this.fogBlue = out[2];
         }
         if (CameraUtil.isUnderLiquid(this.mc.activeCamera, world, Materials.WATER, partialTick)) {
-            if(this.mc.currentWorld != null && this.mc.currentWorld.dimension == Dimension.NETHER) {
+            if(this.mc.currentWorld != null && this.mc.currentWorld.getWorldType().hasTag(WorldTypeTags.NETHER)) {
                 this.fogRed = 0.2F;
                 this.fogGreen = 0.02F;
                 this.fogBlue = 0.02F;
diff --git a/game/client/src/main/java/net/minecraft/client/render/PostProcessingManager.java b/game/client/src/main/java/net/minecraft/client/render/PostProcessingManager.java
index 4832cf391..cb2e8cf61 100644
--- a/game/client/src/main/java/net/minecraft/client/render/PostProcessingManager.java
+++ b/game/client/src/main/java/net/minecraft/client/render/PostProcessingManager.java
@@ -3,10 +3,9 @@ package net.minecraft.client.render;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.option.GameSettings;
 import net.minecraft.core.util.helper.MathHelper;
-import net.minecraft.core.world.Dimension;
 import net.minecraft.core.world.pos.TilePos;
-import net.minecraft.core.world.type.WorldTypes;
 import net.minecraft.core.world.season.Seasons;
+import net.minecraft.core.world.type.tag.WorldTypeTags;
 import net.minecraft.core.world.weather.Weather;
 import net.minecraft.core.world.weather.Weathers;
 import org.jetbrains.annotations.NotNull;
@@ -93,13 +92,13 @@ public class PostProcessingManager {
         this.lastHumidity = humidity;
 
         // Perform base temperature change
-        if (this.mc.currentWorld.dimension == Dimension.OVERWORLD) {
+        if (this.mc.currentWorld.getWorldType().hasTag(WorldTypeTags.OVERWORLD)) {
             this.lastTemperature = temperature;
             final double tt = (temperature * 2) - 1.0; // Ranges from -1.0 to 1.0
             this.current.saturation += (float) (0.25 * tt * surfaceness);
             this.current.contrast += (float) (-0.1 * tt * surfaceness);
         }
-        if (this.mc.currentWorld.dimension == Dimension.NETHER) {
+        if (this.mc.currentWorld.getWorldType().hasTag(WorldTypeTags.HOT)) {
             this.lastTemperature = temperature;
             if (temperature < 0.5) {
                 final double tt = temperature * 2; // Ranges from 0.0 to 1.0
@@ -153,9 +152,9 @@ public class PostProcessingManager {
         }
 
         // Perform dimension effects
-        if (this.mc.currentWorld.dimension == Dimension.NETHER || this.mc.currentWorld.getWorldType() == WorldTypes.OVERWORLD_HELL) {
+        if (this.mc.currentWorld.getWorldType().hasTag(WorldTypeTags.HOT)) {
             float scale = 1.0f;
-            if (this.mc.currentWorld.dimension == Dimension.NETHER && temperature < 0.5) {
+            if (this.mc.currentWorld.getWorldType().hasTag(WorldTypeTags.NETHER) && temperature < 0.5) {
                 scale = (float) temperature * 2.0f;
             }
             this.current.rMod += 1.2f * scale;
@@ -168,7 +167,7 @@ public class PostProcessingManager {
         }
 
         // Perform heatwave effects
-        if (this.mc.currentWorld.dimension == Dimension.OVERWORLD && (this.mc.currentWorld.getSeasonManager().getCurrentSeason() == Seasons.OVERWORLD_SUMMER || this.mc.currentWorld.getSeasonManager().getCurrentSeason() == Seasons.OVERWORLD_FALL)) {
+        if (this.mc.currentWorld.getWorldType().hasTag(WorldTypeTags.OVERWORLD) && (this.mc.currentWorld.getSeasonManager().getCurrentSeason() == Seasons.OVERWORLD_SUMMER || this.mc.currentWorld.getSeasonManager().getCurrentSeason() == Seasons.OVERWORLD_FALL)) {
             if (temperature >= 0.85 && humidity <= 0.15) {
                 final double tPercentage = (temperature - 0.85) / 0.15;
                 final double hPercentage = 1 - (humidity / 0.15);
diff --git a/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java b/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java
index b7562be1d..6e3a48221 100644
--- a/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java
+++ b/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java
@@ -790,14 +790,8 @@ public class RenderGlobal
             timeScalar *= cutoff;
             timeScalar *= rainbowTimeScalar;
 
-            Weather[] blocked = this.world.getBlockBiome(new TilePos(this.mc.thePlayer)).blockedWeathers;
-            boolean isWeatherBlocked = false;
-            for (Weather w : blocked) {
-                if (w.equals(this.world.getWeatherManager().getLastWeather())) {
-                    isWeatherBlocked = true;
-                    break;
-                }
-            }
+            List<Weather> blocked = this.world.getBlockBiome(new TilePos(this.mc.thePlayer)).blockedWeathers;
+            boolean isWeatherBlocked = blocked.contains(this.world.getWeatherManager().getLastWeather());
 
             double targetRainbowBrightness;
             if (isWeatherBlocked) {
